# Book Description

Oracle API Platform Cloud Service is a book that will show you from theory through to practice how to work with the newest Oracle API management platform. This is a critical new platform for Oracle developers in the modern world, to interface to the complex array of services your clients expect.

You’ll first learn about Oracle’s new platform as an overview, and then study a use case that shows the functionality and use of this new platform for Oracle customers. You’ll then work with the power of Apiary, and begin designing your own APIs. From there, you’ll be building and running microservices, and setting up the Oracle API gateways. You’ll move on to discover how to customize the developer portal and publish your own APIs. Naturally you’ll spend time looking at configuration management on the new platform, and implementing the Oauth 2.0 policy, as well as customer policies. The latest finance modules from Oracle will be examined, with some of the third party alternatives in sight as well.

This broad scoped book completes your journey with a clear examination of how to migrate API from Oracle API Management 12c to the new Oracle API Platform, so that you can step into the future confidently.

__The book can be ordered [here](https://bit.ly/APIP-CS) or [here](https://bit.ly/APIP-CS-Amazon)__

# Contents
__Chapter 1 – Platform Overview__ – This chapter provides an overview of the platform, introducing key concepts and the capabilities from the perspective of the management console.

__Chapter 2 – Use Case__ – The chapter describes a hypothetical use case on which we can then illustrate the different aspects of the API Platform Cloud Service. Whilst the case maybe hypothetical the underpinning needs come from real world scenarios the authors have seen.

__Chapter 3 – Designing the API__ – Taking the Use Case, this chapter then goes through the process of designing and developing APIs that will address some of the requirements. This includes using features such as API mocking to test the API behavior.

__Chapter 4 – Building and running the microservice__ – As APIs are natural partners, this chapter will show how the API definition produced can be realized using microservice technologies. To demonstrate the microservice we’ll deploy the service on Amazon using Docker and into Oracle’s Container Cloud.

__Chapter 5 – Platform configuration and gateway setup__ – To be able to manage the API for our microservice, we first need to setup and deploy our Gateway.  This chapter will go into the detail of instantiating API-P, configuring the cloud platform and then deploying a gateway.

__Chapter 6 – Creating and publishing the API__ – With a gateway ready, an API definition, and its implementation, we can now go through the process of looking at the policies available to us, and defining the policies to be used with our APIs and then deploy them.

__Chapter 7 – Testing with API Fortress__ – With an API configured and deployed it needs to be tested. Whilst there are a number of tools available for this task APIFortress has a level of integration with the API-P CS which makes the process even easier. 

__Chapter 8 – Implementing OAuth 2__ – With webservices, particularly REST ones, OAuth is becoming the defacto norm for authentication and authorization for user based credentials. In this chapter, we look at how to setup OAuth2 with the API-P CS.

__Chapter 9 – Implementing Custom Policies__ – API-P CS provides several approaches to develop our own API policies. This chapter will walk through the process of building our own custom API policy using Groovy scripting and using the Java SDK then applying it to our use case.

__Chapter 10 – Moving from API Management 12c to APIP CS__ – API-P CS is not the 1st Oracle API product. API Management 12c represents Oracle’s 2nd generation of API Platform, and for those not starting with a clean sheet will need to understand the options for migrating from the older product.
